/* update netscape for downloading of binary files */
Netscape_binary:
save_trace = Trace('N')

Parse Upper Arg target_drive

Call Rxfuncadd 'SysLoadFuncs','Rexxutil','SysLoadFuncs'
Call SysLoadFuncs

Parse Upper Arg target_drive

If target_drive <> '' Then
   target_drive = Left(target_drive, 1) || ':'
Else
   target_drive = SysBootDrive()

bin_title = 'Binary File'
bin_ext = 'zip exe ptf wpi'
bin_mime = 'file/bin'
reg_root = '\HKEY_CLASSES_ROOT\'
bin_0 = '00'x
bin_help = 'browser-handle-internal-savetodisk' || bin_0
xrc = 1
trace 'N'

nscp_ini = Stream(target_drive || '\os2\nscp.ini', 'c', 'query exists')
nscp_p = SysSearchPath('path', 'nscp.ini')
if translate(nscp_ini) <> translate(nscp_p) then
   do
      if SysIni(nscp_p, 'Netscape Navigator', 'CurrentVersion') <> 'ERROR:' then
         address cmd '@copy' nscp_p nscp_ini '> nul'
      address cmd '@rename' nscp_p 'nscp.org > nul'
   end

If nscp_ini = '' Then
   Do
      Call Rx_sayout 'Unable to locate' nscp_ini, , 1
      Trace(save_trace)
      Return 0
   End

netscape_version = SysIni(nscp_ini, 'Netscape Navigator', 'CurrentVersion')
If netscape_version = 'ERROR:' Then
   Do
      Call Rx_sayout 'Unable to determine Netscape version', , 1
      Trace(save_trace)
      Return 0
   End
netscape_version = Strip(netscape_version, 't', '00'x)
netscape_path = SysIni(nscp_ini, 'Netscape Navigator-' || netscape_version, 'Install Directory')
If netscape_path = 'ERROR:' Then
   Do
      Call Rx_sayout 'Unable to determine Netscape path', , 1
      Trace(save_trace)
      Return 0
   End
netscape_path = Strip(netscape_path, 't', '00'x)
netscape_ini = netscape_path || '\NETSCAPE.INI'
If Stream(netscape_ini, 'c', 'query exists') = '' Then
   Call Rx_sayout 'Unable to locate' netscape_ini || ', will build', , 1

Do i = 1 To Words(bin_ext)
   ext = Word(bin_ext, i)
   If i = 1 Then
      ext_list = '.' || ext
   Else
      ext_list = Space(ext_list || ',.' || ext)
   ext_file = ext || 'file'
   /* update the registry in nscp.ini */
   If SysIni(nscp_ini, 'Registry', reg_root || '.' || ext) <> ext || 'file' || bin_0 Then
      Do
         If SysIni(nscp_ini, 'Registry', reg_root || '.' || ext, ext || 'file' || bin_0) = '' Then
            If SysIni(nscp_ini, 'Registry', reg_root || ext_file, bin_title || bin_0) = '' Then
            If SysIni(nscp_ini, 'Registry', reg_root || ext_file || '\shell', bin_0) = '' Then
            If SysIni(nscp_ini, 'Registry', reg_root || ext_file || '\shell\open', bin_0) = '' Then
            If SysIni(nscp_ini, 'Registry', reg_root || ext_file || '\shell\open\command', bin_0) = '' Then
            Call Rx_sayout 'Update of' nscp_ini 'for file extention' ext 'complete', , 1
         Else
            Call Rx_sayout 'Update of' nscp_ini 'for file extension' ext 'failed', , 1
      End
   Else
      Call Rx_sayout 'Update of' nscp_ini 'file extension' ext 'not required', , 1
End

/* update netscape.ini */
If SysIni(netscape_ini, 'Suffixes', bin_mime) <> ext_list || bin_0 Then
      Do
         If SysIni(netscape_ini, 'Suffixes', bin_mime, ext_list || bin_0) = '' Then
            If SysIni(netscape_ini, 'Viewers', bin_mime, bin_help) = '' Then
            Do
               /* check the TYPEx entries */
               type. = ''
               type.0 = 0
               Do i = 0 Until ans = 'ERROR:'
                  ans = SysIni(netscape_ini, 'Viewers', 'TYPE' || i)
                  If ans <> 'ERROR:' Then
                  Do
                     j = type.0 + 1
                     type.j = ans
                     type.0 = j
                  End
            End
            found = 0
            Do i = 1 To type.0
               If Abbrev(type.i, bin_mime) Then
                  found = 1
            End
            If \found Then
               Do
                  new_type = 'TYPE' || type.0
                  If SysIni(netscape_ini, 'Viewers', new_type, bin_mime || bin_0) = '' Then
                     Call Rx_sayout 'Update of' netscape_ini 'complete', , 1
                  Else
                     Do
                        Call Rx_sayout 'Update of' netscape_ini 'failed', , 1
                        xrc = 0
                     End
                  End
            Else
               Call Rx_sayout 'Update of' netscape_ini 'complete', , 1
         End
      Else
         Do
            Call Rx_sayout 'Update of' netscape_ini 'failed', , 1
            xrc = 0
         End
   End
Else
   Call Rx_sayout 'Update of' netscape_ini 'not required', , 1
Trace(save_trace)
Return xrc

/*:VRX         Rx_sayout
Usage:  Rx_Sayout(message, <message level>, <log option>)
Where:     message = message to be output
           message level = number of spaces to indent
           log option = null - log to log file
                        1    - log only, no message output
                        -1   - no log, message output only
Result:    message level
*/
Rx_sayout: Procedure Expose (log_parms)
/* console and log file output */
save_trace = Trace('N')
/* test exposed parameters */
If \Datatype(verbose, 'b') Then
   verbose = 1
If \Datatype(log_out, 'b') Then
   Do
      xrc = SysFileTree(log_file, 'test.', 'fo')
      If xrc = 0 & test.0 <> 0 Then
         log_out = 1
      Else
         log_out = 0
   End
If \Datatype(log_lines.0, 'w') Then
   log_lines.0 = 0
Parse Arg msg, level, log_parm
If \Datatype(level, 'w') Then
   level = 0
If \Datatype(log_parm, 'w') Then
   log_parm = 0
log_only = log_out & (log_parm > 0)
no_log = log_out & (log_parm < 0)
msg = Copies(' ', level) || msg
If verbose & \log_only Then
   Say msg
If \no_log Then
   Do
      If log_out Then
         Call Lineout log_file, Date() Time() msg
      Else
         Do
            x = log_lines.0 + 1
            log_lines.x = level Strip(msg)
            log_lines.0 = x
         End
   End
Trace(save_trace)
Return level
